function [ mse_p ] = avg_mse(X,T1,T2,tao,cons1,cons2,k,NRep,TRep,indN,options)
% This program:
% (1) randomly cut the N by T matrix X into two halves 
% (2) estimate the stucture of the model with first half
% (3) given the structure, calcuate predictive mse using the second half 
% OUTPUT: Avearge predictive MSE for given Tuning parameter
% INPUT:  Date X is NXT
%        T1:  before break time (uknown case, before earliest break)
%        T2:  post break periods (unknown case, after latest break)
%        T22: post break portion used for training 
%        T23: post break portion used for prediction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
M_V   = zeros(NRep,TRep); 
                                          
%-------------------------------------------------------------------------
%         CV loop over N and T partitions start from here
%-------------------------------------------------------------------------

for i=1:NRep
        
    
%-------------------------standard k-fold in N dim-------------------------
          
        
        testN = (indN == i);        trainN = ~testN;
    

%--------------------------------------------------------------------------
       
        XR =X(testN,:);
        XL= X(trainN,:);         
        NL = size(XL,1);  
    
        Xtemp = [XL;XR];
        
        X1 = Xtemp(:,1:T1);    %pre-break subsample
        X2 =Xtemp(:,T1+1:end); %post-break subsample   
    

%--------------------------------------------------------------------------
%          tao input could be a scalar (known) or vector (unknown)
%-------------------------------------------------------------------------- 
  
    if length(tao)==1  
  
        [r1_hat,r2_hat,D] = selectedmodel(XL,tao,cons1,cons2,k,options);
  
    else
        [r1_hat,r2_hat,D] = selectedmodel_unknown(XL,tao,cons1,cons2,k,options);
    end
    
    
%--------------------------------------------------------------------------

           
    for j = 1:TRep        
         nd = 2;
        
        roll_block1 = floor(T1/2/(TRep+nd));
        roll_block2 = floor(T2/2/(TRep+nd));        
       
        
        trainT1_stt =   1 + roll_block1*(j-1);        
        trainT1_end =   trainT1_stt + floor(T1/2) - 1 ;
        
        testT1_stt  =   trainT1_end + roll_block1*nd + 1 ;                                 
        testT1_end  =   testT1_stt + roll_block1 - 1; 
        
        trainT2_stt =   1 + roll_block2*(j-1);        
        trainT2_end =   trainT2_stt + floor(T2/2) - 1;
        
        testT2_stt  =   trainT2_end + roll_block2*nd + 1 ;
        testT2_end  =   testT2_stt + roll_block2 -1; 
        
       
        trainT1     =   trainT1_stt:trainT1_end;
        testT1      =   testT1_stt:testT1_end;
        trainT2     =   trainT2_stt:trainT2_end;
        testT2      =   testT2_stt:testT2_end;  
         
 
        
        X13=X1(:,testT1);
        X12=X1(:,trainT1);
        
        X23=X2(:,testT2);
        X22=X2(:,trainT2);
    
    
        Xtemp=[X13,X12,X22,X23]; %re-organize the data    
        
        XR =Xtemp(NL+1:end,:);
        XL= Xtemp(1:NL,:); 
        
        T13 = size(X13,2);
        T23 = size(X23,2); % number of periods in X23        
        
        Ta = size(X12,2)+size(X13,2);
        Tb = size(X22,2)+size(X23,2);
        
        
        M_V(i,j) = mse_cv(XL,XR,r1_hat,r2_hat,D,Ta,Tb,T13,T23); 
        
    end
    
    
end


mse_p = mean(mean(M_V));

end

