function [Tuning, fpara0] = tuningpara12(X,tao,k,cons1,cons2,options)

        dp = 2;   [N,T]  = size(X);   T1 = floor(T*tao); 
        T2 = T-T1; X1    = X(:,1:T1); X2 = X(:,T1+1:end);
%--------------------------------------------------------------------------
%          principle component estimator of factors and loadings 
%--------------------------------------------------------------------------
    groups = zeros(2*N*k,1); 
for i = 1:k   
    s = (i-1)*N+1;     e = i*N;   
    groups(s:e) = i;
    s = (k+(i-1))*N+1; e = (k+i)*N; 
    groups(s:e) = k+i;  
end  
%--------------------------------------------------------------------------
%          principle component estimator of factors and loadings 
%--------------------------------------------------------------------------
        [F1_til,F2_til,lambda1_til,lambda2_til] = pc(X,T1,T2,k);  
%--------------------------------------------------------------------------
%              preliminary estimator of residuals
%--------------------------------------------------------------------------    
        R1 = X1-lambda1_til*F1_til';  R2 = X2-lambda2_til*F2_til';  
%--------------------------------------------------------------------------
%                preliminary tuning parameter
%--------------------------------------------------------------------------   
        e1 = norm(R1,'fro')/(N*T1)^.5+norm(R2,'fro')/(N*T2)^.5;
        e2 = norm(R2,'fro')/(N*T2)^.5;

        Ftuning10 = cons1*N^(-.5)*max((T1)^(-(dp+1)/2),N^(-(dp+1)/2));     % a constant in the tuning parameter for penalization
        Ftuning20 = cons2*N^(-.5)*max((T2)^(-(dp+1)/2),N^(-(dp+1)/2));     % a constant in the tuning parameter for penalization

        norml     = sqrt(diag(lambda1_til'*lambda1_til))';                 % column norms of Lambda1
        gamma_til = lambda2_til-lambda1_til; 
        normg     = sqrt(diag(gamma_til'*gamma_til))';                     % column norms of Gamma
        
        Ftuning1  = e1*Ftuning10*N^dp*(norml.^(-2*dp));
        Ftuning2  = e2*Ftuning20*N^dp*(normg.^(-2*dp));
%--------------------------------------------------------------------------
%      shrinkage estimation based on initial tuning parameter
%--------------------------------------------------------------------------   
        funObj    = @(para)pel_ls(para,X,F1_til,F2_til);                   % criterion function function
        fpara     = [lambda1_til gamma_til];
        fpara0    = reshape(fpara,2*N*k,1);                                % starting values
        Tuning    = [Ftuning1';Ftuning2'];
        paraest0  = L1GeneralGroup_Auxiliary(funObj,fpara0,Tuning,groups,options);
        fest0     = reshape(paraest0,N,2*k);                               % preliminary estimator
%--------------------------------------------------------------------------
%      shrinkage estimation based on initial tuning parameter
%--------------------------------------------------------------------------   
           A = diag(fest0'*fest0); A1 = A(1:k); A2 = A(k+1:2*k);
        
if norm(A1) == 0; 
    er1 = 0;   
else
    er1 = find(A1,1,'last'); 
end

if norm(A2) == 0; 
    er2 = er1; 
else
    er2 = find(A2,1,'last'); er2 = max(er1,er2); 
end
 
        F1_se      = F1_til(:,1:er1);      
        lambda1_se = lambda1_til(:,1:er1);
        F2_se      = F2_til(:,1:er2);      
        lambda2_se = lambda2_til(:,1:er2);
        R1_se      = X1-lambda1_se*F1_se'; 
        R2_se      = X2-lambda2_se*F2_se';
        e1         = norm(R1_se,'fro')/(N*T1)^.5+norm(R2_se,'fro')/(N*T2)^.5;
        e2         = norm(R2_se,'fro')/(N*T2)^.5; 

if er1==er2
    lambda2_tr = rotation_lamb2(lambda1_se,lambda2_se,er1); 
else
    lambda2_tr = lambda2_se;
end
 
         gamma_se       = lambda2_tr-[lambda1_se,zeros(N,er2-er1)]; 
         normg_se       = sqrt(diag(gamma_se'*gamma_se))';                 % column norms of Gamma_se
         normg_n        = normg;
         normg_n(1:er2) = normg_se;                                        % update norm
         Ftuning1       = e1*Ftuning10*(N^2)*(norml.^(-2*dp));
         Ftuning2       = e2*Ftuning20*(N^2)*(normg_n.^(-2*dp));
         Tuning         = [Ftuning1';Ftuning2'];



