function [Tuning,f0,cons1,cons2,MSE_P] = tuningpara_cv(X,T1,T2,tao,k,NRep,TRep,options)

[N,~]   = size(X);
cons1V  = [1/6, 1/4, 1/2, 3/4, 1, 2, 3];
cons2V  = [1/6, 1/4, 1/2, 3/4, 1, 2, 3];

aRep    = size(cons1V,2);
bRep    = size(cons2V,2);
cons1V  = kron(cons1V,ones(1,bRep));
cons2V  = kron(ones(1,aRep),cons2V);
Rep     = aRep*bRep;
MSE_P   = zeros(Rep,1);

indN    = crossvalind('Kfold',N,NRep);
indN    = sort(indN);

for i = 1:Rep
    
MSE_P(i) = avg_mse(X,T1,T2,tao,cons1V(i),cons2V(i),k,NRep,TRep,indN,options);
    
end 

[~, minIndx] = min(MSE_P);
cons1        = cons1V(minIndx);
cons2        = cons2V(minIndx);

[Tuning,f0]  = tuningpara12(X,tao,k,cons1,cons2,options);

end